﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace WeakReferance
{
    public class MyButton
    {

        private class WeakDelegate
        {
            public WeakReference Target;
            public MethodInfo Method;
            public bool IsInstance;
        }

        private List<WeakDelegate> clickSubscribers = new List<WeakDelegate>();

        public event EventHandler Click
        {
            add
            {
                clickSubscribers.Add(new WeakDelegate
                {
                    Target = new WeakReference(value.Target),
                    Method = value.Method,
                    IsInstance = value.Target == null ? false : true

                });
            }
            remove
            {
                clickSubscribers.RemoveAll(subscriber => subscriber.Method == value.Method);
            }

        }

        public void FireClick()
        {
            List<WeakDelegate> toRemove = new List<WeakDelegate>();
            foreach (WeakDelegate subscriber in clickSubscribers)
            {
                object target = subscriber.Target.Target;
                if (target == null && subscriber.IsInstance)
                {
                    toRemove.Add(subscriber);
                }
                else
                {
                    subscriber.Method.Invoke(target, new object[] { this, EventArgs.Empty });
                }
            }

            foreach (var s in toRemove)
            {
                clickSubscribers.Remove(s);
            }
        }
    }
}
